--
-- ReversingCamera for FS17
-- You can look back throw the left window when you are reversing with truck and trailer.
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0 - 2017-09-11 -
--				v1.1 - 2017-09-17 - added controls for position of reverse camera
-- 
ReversingCamera_Register = {};

if SpecializationUtil.specializations["ReversingCamera"] == nil then
	SpecializationUtil.registerSpecialization("ReversingCamera", "ReversingCamera", g_currentModDirectory.."ReversingCamera.lua")
	ReversingCamera_Register.isLoaded = false;
end;

function ReversingCamera_Register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("drivable")then
						local v_name_string = v.name 
						local point_location = string.find(v_name_string, ".", nil, true)
						if point_location ~= nil then
							local _name = string.sub(v_name_string, 1, point_location-1);
							if rawget(SpecializationUtil.specializations, string.format("%s.ReversingCamera", _name)) ~= nil then
								allowInsertion = false;								
							end;							
						end;
						if allowInsertion then	
							table.insert(v.specializations, SpecializationUtil.getSpecialization("ReversingCamera"));
						end;
					end;
				end;
			end;	
		end;
		
	end;
end;	

function ReversingCamera_Register:deleteMap()
  
end;

function ReversingCamera_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function ReversingCamera_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function ReversingCamera_Register:update(dt)
	
end;

function ReversingCamera_Register:draw()
end;

addModEventListener(ReversingCamera_Register);